summaryrefslogtreecommitdiff
path: root/tests
diff options
context:
space:
mode:
authorRichard Maw <richard.maw@codethink.co.uk>2012-06-14 13:03:04 +0000
committerRichard Maw <richard.maw@codethink.co.uk>2012-06-14 13:03:04 +0000
commitf7790e2ec52b3cc3f8b58f3e447da37361ff9580 (patch)
tree91da03d0a6c70a7ccccc80c9d990b95dd1d9f54e /tests
parent9101b1839abe305545f487b10939b498e1c09280 (diff)
downloadmorph-f7790e2ec52b3cc3f8b58f3e447da37361ff9580.tar.gz
tests: verify overlaps are written to the cache
This adds a new script called list-overlaps, which when given a json dump of the overlap can be used to query what is overlapping The tests use this script to check that the overlaps are detected
Diffstat (limited to 'tests')
-rwxr-xr-xtests/stratum-overlap-writes-overlap.script34
l---------tests/stratum-overlap-writes-overlap.setup1
-rw-r--r--tests/stratum-overlap-writes-overlap.stdout4
3 files changed, 39 insertions, 0 deletions
diff --git a/tests/stratum-overlap-writes-overlap.script b/tests/stratum-overlap-writes-overlap.script
new file mode 100755
index 00000000..28d3d044
--- /dev/null
+++ b/tests/stratum-overlap-writes-overlap.script
@@ -0,0 +1,34 @@
+#!/bin/sh
+#
+# If a stratum has multiple chunks that have the same files in them,
+# then the overlaps must be written to the cache
+#
+# Copyright (C) 2011, 2012 Codethink Limited
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+set -eu
+
+cache="$DATADIR/cache/artifacts"
+
+
+"$SRCDIR/scripts/test-morph" \
+ build test:morphs-repo overlap overlap-stratum.morph
+"$SRCDIR/scripts/list-overlaps" groups \
+ "$cache"/*.stratum.overlap-stratum.overlaps |
+while IFS='\n' read overlaps; do
+ echo $overlaps
+ "$SRCDIR/scripts/list-overlaps" list-files \
+ "$cache"/*.stratum.overlap-stratum.overlaps $overlaps
+done
diff --git a/tests/stratum-overlap-writes-overlap.setup b/tests/stratum-overlap-writes-overlap.setup
new file mode 120000
index 00000000..255e9a74
--- /dev/null
+++ b/tests/stratum-overlap-writes-overlap.setup
@@ -0,0 +1 @@
+stratum-overlap-warns.setup \ No newline at end of file
diff --git a/tests/stratum-overlap-writes-overlap.stdout b/tests/stratum-overlap-writes-overlap.stdout
new file mode 100644
index 00000000..40485659
--- /dev/null
+++ b/tests/stratum-overlap-writes-overlap.stdout
@@ -0,0 +1,4 @@
+overlap-foo-baz overlap-foobar overlap-fooqux
+bin/foo
+overlap-foo-baz overlap-foobar
+bin/bar